diff -uwrN sourceold/scripts/jmgUtility.cpp source/scripts/jmgUtility.cpp
--- sourceold/scripts/jmgUtility.cpp	2017-12-29 17:04:51.889600100 +1000
+++ source/scripts/jmgUtility.cpp	2018-11-11 08:30:08.535600000 +1000
@@ -5451,6 +5621,18 @@
 	huntStealth = Get_Int_Parameter("HuntStealth") ? true : false;
 	removeIgnoreTime = 0;
 	ignoreEnemyId = 0;
+	wanderingAiGroupId = Get_Int_Parameter("WanderingAIGroupID");
+	wanderSpeed = Get_Float_Parameter("WanderSpeed");
+	huntSpeed = Get_Float_Parameter("HuntSpeed");
+	attackSpeed = Get_Float_Parameter("AttackSpeed");
+	returnHomeSpeed = Get_Float_Parameter("ReturnHomeSpeed");
+	changeWanderGroupCustom = Get_Int_Parameter("ChangeWanderGroupCustom");
+	changeWanderSpeedCustom = Get_Int_Parameter("ChangeWanderSpeedCustom");
+	changeHuntDistanceCustom = Get_Int_Parameter("ChangeHuntDistanceCustom");
+	changeHuntSpeedCustom = Get_Int_Parameter("ChangeHuntSpeedCustom");
+	changeReturnHomeSpeedCustom = Get_Int_Parameter("ChangeReturnHomeSpeedCustom");
+	changeMaxSightFromHomeLocationCustom = Get_Int_Parameter("ChangeMaxSightFromHomeLocationCustom");
+	changeAttackSpeedCustom = Get_Int_Parameter("ChangeAttackSpeedCustom");
 	maxSightFromHomeLocation = Get_Float_Parameter("MaxSightRangeFromHome");
 	maxSightFromHomeLocation *= maxSightFromHomeLocation;
 	huntSearchDistance = Get_Float_Parameter("HuntSearchDistance") < 0.0f ? Get_Float_Parameter("HuntSearchDistance") : Get_Float_Parameter("HuntSearchDistance")*Get_Float_Parameter("HuntSearchDistance");
@@ -5462,6 +5644,8 @@
 	}
 	attackArriveDistance = Get_Float_Parameter("AttackDistance") >= 0 ? Get_Float_Parameter("AttackDistance") : weaponEffectiveRange;
 	huntArriveDistance = Get_Float_Parameter("HuntArriveDistance");
+	wanderDistanceOverride = Get_Float_Parameter("WanderDistanceOverride");
+	wanderDistanceOverride *= wanderDistanceOverride;
 	Commands->Enable_Enemy_Seen(obj,true);
 	Commands->Start_Timer(obj,this,1.0f,1);
 	Commands->Start_Timer(obj,this,1.0f,2);
@@ -5495,7 +5679,7 @@
 		targetId = Commands->Get_ID(seen);
 		lastSeenTime = Commands->Get_Random_Int(30,60);
 		state = ATTACKING_TARGET;
-		Attack_Move(obj,seen,Vector3(),Get_Float_Parameter("AttackSpeed"),attackArriveDistance,true,false);
+		Attack_Move(obj,seen,Vector3(),attackSpeed,attackArriveDistance,true,false);
 	}
 	if (targetId == Commands->Get_ID(seen))
 		lastSeenTime = Commands->Get_Random_Int(30,60);
@@ -5510,25 +5694,26 @@
 			lastSeenTime--;
 			if (!lastSeenTime)
 			{
+				Return_Home(obj,ValidLastLocation(targetId));
 				targetId = 0;
-				Return_Home(obj);
 			}
 		}
 		if (targetId)
 		{
 			GameObject *target = Commands->Find_Object(targetId);
 			targetPos = Commands->Get_Position(target);
-			if (!target || !Commands->Get_Health(target) || Commands->Get_Player_Type(target) == -2 || (Commands->Get_Player_Type(obj) != -1 && Commands->Get_Player_Type(target) == Commands->Get_Player_Type(obj)))
+			if (!target || !Commands->Get_Health(target) || (Commands->Get_Player_Type(obj) != -2 && Commands->Get_Player_Type(target) == Commands->Get_Player_Type(obj)) || Is_Script_Attached(target,"JMG_Utility_AI_Goto_Enemy_Not_Star_Ignore_Object"))
 			{
+				lastSeenTime = 0;
+				Return_Home(obj,ValidLastLocation(targetId));
 				targetId = 0;
-				Return_Home(obj);
 			}
 		}
 		if (state == HUNTING_STAR)
 		{
 			GameObject *star = Commands->Find_Object(huntingEnemyId);
-			if (!star || !Commands->Get_Health(star))
-				Return_Home(obj);
+			if (!star || !Commands->Get_Health(star) || (huntSearchDistance >= 0.0f && JmgUtility::SimpleDistance(Commands->Get_Position(star),Commands->Get_Position(obj)) > huntSearchDistance) || Is_Script_Attached(star,"JMG_Utility_AI_Goto_Enemy_Not_Star_Ignore_Object"))
+				Return_Home(obj,false);
 		}
 		if (state == IDLE || state == RETURNING_HOME || state == WANDERING_GROUP)
 		{
@@ -5536,27 +5721,21 @@
 			if (star)
 			{
 				state = HUNTING_STAR;
-				Attack_Move(obj,star,Vector3(),Get_Float_Parameter("HuntSpeed"),huntArriveDistance,false,false);
+				Attack_Move(obj,star,Vector3(),huntSpeed,huntArriveDistance,false,false);
 			}
 		}
-		if (state == HUNTING_STAR)
-		{
-			GameObject *star = Commands->Find_Object(huntingEnemyId);
-			if (!star || (huntSearchDistance >= 0.0f && JmgUtility::SimpleDistance(Commands->Get_Position(star),Commands->Get_Position(obj)) > huntSearchDistance))
-				Return_Home(obj);
-		}
-		if (state == IDLE && Get_Int_Parameter("WanderingAIGroupID") != -1)
+		if (state == IDLE && wanderingAiGroupId != -1)
 		{
 			Vector3 wanderPos = Vector3();
 			if (GetRandomPosition(&wanderPos))
 			{
 				state = WANDERING_GROUP;
 				homeLocation = wanderPos;
-				Attack_Move(obj,NULL,wanderPos,Get_Float_Parameter("WanderSpeed"),1.0f,false,false);
+				Attack_Move(obj,NULL,wanderPos,wanderSpeed,1.0f,false,false);
 			}
 		}
 		if (state == RETURNING_HOME || state == WANDERING_GROUP)
-			if (JmgUtility::SimpleDistance(lastAction.location,Commands->Get_Position(obj)) <= (obj->As_VehicleGameObj() ? 25.0f : 1.0f))
+			if (JmgUtility::SimpleDistance(lastAction.location,Commands->Get_Position(obj)) <= (wanderDistanceOverride != 0 ? wanderDistanceOverride : (obj->As_VehicleGameObj() ? 25.0f : 1.0f)))
 				state = IDLE;
 		if (state == ACTION_BADPATH)
 			Cant_Get_To_target(obj);
@@ -5585,6 +5764,57 @@
 		huntArriveDistance += Commands->Get_Random(Get_Float_Parameter("RandomHuntArriveDistance"),Get_Float_Parameter("RandomHuntArriveDistance"));
 	}
 }
+void JMG_Utility_AI_Goto_Enemy_Not_Star::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (changeWanderGroupCustom != 0 && changeWanderGroupCustom == message)
+	{
+		wanderingAiGroupId = param;
+		if (state == WANDERING_GROUP)
+		{
+			Vector3 wanderPos = Vector3();
+			if (GetRandomPosition(&wanderPos))
+			{
+				homeLocation = wanderPos;
+				Attack_Move(obj,Commands->Find_Object(lastAction.targetId),homeLocation,lastAction.speed,lastAction.distance,lastAction.attack,lastAction.overrideLocation);
+			}
+		}
+	}
+	if (changeWanderSpeedCustom != 0 && changeWanderSpeedCustom == message)
+	{
+		wanderSpeed = param/100.0f;
+		if (state == WANDERING_GROUP)
+			Attack_Move(obj,Commands->Find_Object(lastAction.targetId),lastAction.location,wanderSpeed,lastAction.distance,lastAction.attack,lastAction.overrideLocation);
+	}
+	if (changeHuntDistanceCustom != 0 && changeHuntDistanceCustom == message)
+	{
+		huntSearchDistance = param/100.0f;
+		if (huntSearchDistance > 0)
+			huntSearchDistance *= huntSearchDistance;
+	}
+	if (changeHuntSpeedCustom != 0 && changeHuntSpeedCustom == message)
+	{
+		huntSpeed = param/100.0f;
+		if (state == HUNTING_STAR)
+			Attack_Move(obj,Commands->Find_Object(lastAction.targetId),lastAction.location,huntSpeed,lastAction.distance,lastAction.attack,lastAction.overrideLocation);
+	}
+	if (changeReturnHomeSpeedCustom != 0 && changeReturnHomeSpeedCustom == message)
+	{
+		returnHomeSpeed = param/100.0f;
+		if (state == RETURNING_HOME)
+			Attack_Move(obj,Commands->Find_Object(lastAction.targetId),lastAction.location,returnHomeSpeed,lastAction.distance,lastAction.attack,lastAction.overrideLocation);
+	}
+	if (changeMaxSightFromHomeLocationCustom != 0 && changeMaxSightFromHomeLocationCustom == message)
+	{
+		maxSightFromHomeLocation = param/100.0f;
+		maxSightFromHomeLocation *= maxSightFromHomeLocation;
+	}
+	if (changeAttackSpeedCustom != 0 && changeAttackSpeedCustom == message)
+	{
+		attackSpeed = param/100.0f;
+		if (state == ATTACKING_TARGET)
+			Attack_Move(obj,Commands->Find_Object(lastAction.targetId),lastAction.location,attackSpeed,lastAction.distance,lastAction.attack,lastAction.overrideLocation);
+	}
+}
 void JMG_Utility_AI_Goto_Enemy_Not_Star::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason reason)
 {
 	if (reason == ACTION_COMPLETE_PATH_BAD_DEST)
@@ -5612,7 +5842,7 @@
 		targetId = Commands->Get_ID(damager);
 		lastSeenTime = Commands->Get_Random_Int(30,60);
 		state = ATTACKING_TARGET;
-		Attack_Move(obj,damager,Vector3(),Get_Float_Parameter("AttackSpeed"),attackArriveDistance,true,false);
+		Attack_Move(obj,damager,Vector3(),attackSpeed,attackArriveDistance,true,false);
 	}
 }
 void JMG_Utility_AI_Goto_Enemy_Not_Star::Attack_Move(GameObject *obj,GameObject *target,Vector3 location,float speed,float distance,bool attack,bool overrideLocation)
@@ -5651,7 +5881,7 @@
 		return NULL;
 	GameObject *nearest = NULL;
 	float nearDist = -1.0f;
-	Vector3 pos = maxSightFromHomeLocation > 0 ? homeLocation : Commands->Get_Position(obj);
+	Vector3 pos = Commands->Get_Position(obj);
 	int myPlayerType = Commands->Get_Player_Type(obj);
 	for (SLNode<SmartGameObj> *current = GameObjManager::SmartGameObjList.Head();current;current = current->Next())
 	{
@@ -5674,6 +5904,8 @@
 			else if (o->As_SmartGameObj() && o->As_SmartGameObj()->Is_Stealthed())
 				continue;
 		}
+		if (maxSightFromHomeLocation > 0 && JmgUtility::SimpleDistance(homeLocation,Commands->Get_Position(o)) > maxSightFromHomeLocation)
+			continue;
 		float tempDist = JmgUtility::SimpleDistance(pos,Commands->Get_Position(o));
 		if (huntSearchDistance >= 0.0f && tempDist > huntSearchDistance)
 			continue;
@@ -5686,18 +5918,23 @@
 	}
 	return nearest;
 }
-void JMG_Utility_AI_Goto_Enemy_Not_Star::Return_Home(GameObject *obj)
+void JMG_Utility_AI_Goto_Enemy_Not_Star::Return_Home(GameObject *obj,ValidLastLocation goNearLastWanderPoint)
 {
-	Vector3 wanderPos = Vector3();
-	if (Get_Int_Parameter("WanderingAIGroupID") != -1 && GetRandomPosition(&wanderPos))
+	Vector3 wanderPos;
+	if (goNearLastWanderPoint.valid && Commands->Get_Random(0.0f,1.0f) < Get_Float_Parameter("ChanceToInvestigateLastSeenLocation"))
 	{
 		state = WANDERING_GROUP;
-		Attack_Move(obj,NULL,wanderPos,Get_Float_Parameter("WanderSpeed"),1.0f,false,false);
+		Attack_Move(obj,NULL,goNearLastWanderPoint.location,wanderSpeed,1.0f,false,false);
+	}
+	else if (wanderingAiGroupId != -1 && GetRandomPosition(&wanderPos))
+	{
+		state = WANDERING_GROUP;
+		Attack_Move(obj,NULL,wanderPos,wanderSpeed,1.0f,false,false);
 	}
 	else if (Get_Int_Parameter("ReturnHome"))
 	{
 		state = RETURNING_HOME;
-		Attack_Move(obj,NULL,homeLocation,Get_Float_Parameter("ReturnHomeSpeed"),1.0f,false,false);
+		Attack_Move(obj,NULL,homeLocation,returnHomeSpeed,1.0f,false,false);
 	}
 	else
 	{
@@ -5751,17 +5988,17 @@
 	if (star && Commands->Get_ID(star) != ignoreEnemyId)
 	{
 		state = HUNTING_STAR;
-		Attack_Move(obj,Commands->Find_Object(lastAction.targetId),Commands->Get_Position(star),Get_Float_Parameter("HuntSpeed"),huntArriveDistance,true,true);
+		Attack_Move(obj,Commands->Find_Object(lastAction.targetId),Commands->Get_Position(star),huntSpeed,huntArriveDistance,true,true);
 	}
-	else if (Get_Int_Parameter("WanderingAIGroupID") != -1 && GetRandomPosition(&wanderPos))
+	else if (wanderingAiGroupId != -1 && GetRandomPosition(&wanderPos))
 	{
 		state = WANDERING_GROUP;
-		Attack_Move(obj,Commands->Find_Object(lastAction.targetId),wanderPos,Get_Float_Parameter("WanderSpeed"),1.0f,true,true);
+		Attack_Move(obj,NULL,wanderPos,wanderSpeed,1.0f,true,true);
 	}
 	else
 	{
 		state = RETURNING_HOME;
-		Attack_Move(obj,Commands->Find_Object(lastAction.targetId),homeLocation,Get_Float_Parameter("ReturnHomeSpeed"),1.0f,true,true);
+		Attack_Move(obj,NULL,homeLocation,returnHomeSpeed,1.0f,true,true);
 	}
 }
 bool JMG_Utility_AI_Goto_Enemy_Not_Star::Choose_Target(GameObject *obj,GameObject *target)
@@ -5774,6 +6011,17 @@
 		return true;
 	return false;
 }
+JMG_Utility_AI_Goto_Enemy_Not_Star::ValidLastLocation::ValidLastLocation(int enemyId)
+{
+	GameObject *target = Commands->Find_Object(enemyId);
+	if (!target || !Commands->Get_Health(target))
+	{
+		this->valid = false;
+		return;
+	}
+	this->location = Commands->Get_Position(target);
+	this->valid = true;
+}
 void JMG_Utility_Grant_Key_On_Create::Created(GameObject *obj)
 {
 	Commands->Grant_Key(obj,Get_Int_Parameter("Key"),Get_Int_Parameter("Grant") ? true : false);
@@ -5781,14 +6029,21 @@
 void JMG_Utility_Custom_Send_Custom::Created(GameObject *obj)
 {
 	recieveMessage = Get_Int_Parameter("Custom");
+	id = Get_Int_Parameter("ID");
+	custom = Get_Int_Parameter("SendCustom");
+	Param = Get_Int_Parameter("Param");
+	delay = Get_Float_Parameter("Delay");
+	randomDelay = Get_Float_Parameter("RandomDelay");
+	randomChance = Get_Float_Parameter("RandomChance");
 }
 void JMG_Utility_Custom_Send_Custom::Custom(GameObject *obj,int message,int param,GameObject *sender)
 {
 	if (message == recieveMessage)
 	{
-		int id = Get_Int_Parameter("ID");
+		if (randomChance && randomChance < Commands->Get_Random(0.0f,1.0f))
+			return;
 		GameObject *object = id ? (id == -1 ? sender : Commands->Find_Object(id)) : obj;
-		Commands->Send_Custom_Event(obj,object,Get_Int_Parameter("SendCustom"),Get_Int_Parameter("Param"),Get_Float_Parameter("Delay"));
+ 		Commands->Send_Custom_Event(obj,object,custom,Param == -1 ? param : Param,delay+(randomDelay > 0 ? Commands->Get_Random(0.0f,randomDelay) : 0.0f));
 	}
 }
 void JMG_Utility_Damage_Unoccupied_Vehicle::Created(GameObject *obj)
@@ -5887,7 +6142,7 @@
 		if (EnemyID)
 		{
 			GameObject *Target = Commands->Find_Object(EnemyID);
-			if (!Target || !Commands->Get_Health(Target) || Commands->Get_Player_Type(Target) == Commands->Get_Player_Type(obj))
+			if (!Target || !Commands->Get_Health(Target) || (Commands->Get_Player_Type(obj) != -2 && Commands->Get_Player_Type(Target) == Commands->Get_Player_Type(obj)))
 			{
 				EnemyID = 0;
 				Goto_Location(obj);
@@ -5948,7 +6203,7 @@
 }
 void JMG_Utility_AI_Guardian_Vehicle::Damaged(GameObject *obj,GameObject *damager,float damage)
 {
-	if (damage <= 0 || (EnemyID && EnemyTimeOutTime) || Commands->Get_Player_Type(damager) == Commands->Get_Player_Type(obj))
+	if (damage <= 0 || (EnemyID && EnemyTimeOutTime) || (Commands->Get_Player_Type(obj) != -2 && Commands->Get_Player_Type(damager) == Commands->Get_Player_Type(obj)))
 		return;
 	EnemyID = Commands->Get_ID(damager);
 	EnemyTimeOutTime = Commands->Get_Random_Int(2,5);
@@ -7195,7 +7450,7 @@
 				if (dist > warnDistance)
 				{
 					screenEffectOn[x] = true;
-					float TempDistCalc = 1-(dist-maxSurviveDistance)/(warnDistance-maxSurviveDistance);
+					float TempDistCalc = min(1-(dist-maxSurviveDistance)/(warnDistance-maxSurviveDistance),1.0f);
 					float inverted = 1-TempDistCalc;
 					Set_Screen_Fade_Color_Player(player,JMG_Utility_Set_Screen_Color_Fade_Controller::color[x].X*inverted+screenFadeColor.X,JMG_Utility_Set_Screen_Color_Fade_Controller::color[x].Y*inverted+screenFadeColor.Y,JMG_Utility_Set_Screen_Color_Fade_Controller::color[x].Z*inverted+screenFadeColor.Z,0.1f);
 					Set_Screen_Fade_Opacity_Player(player,JMG_Utility_Set_Screen_Color_Fade_Controller::opacity[x]*inverted+TempDistCalc,0.1f);
@@ -7221,7 +7476,7 @@
 					if (dist > aircraftWarnDistance)
 					{
 						screenEffectOn[x] = true;
-						float TempDistCalc = 1-(dist-maxSurviveDistance)/(aircraftWarnDistance-maxSurviveDistance);
+						float TempDistCalc = min(1-(dist-maxSurviveDistance)/(aircraftWarnDistance-maxSurviveDistance),1.0f);
 						float inverted = 1-TempDistCalc;
 						Set_Screen_Fade_Color_Player(player,JMG_Utility_Set_Screen_Color_Fade_Controller::color[x].X*inverted+screenFadeColor.X,JMG_Utility_Set_Screen_Color_Fade_Controller::color[x].Y*inverted+screenFadeColor.Y,JMG_Utility_Set_Screen_Color_Fade_Controller::color[x].Z*inverted+screenFadeColor.Z,0.1f);
 						Set_Screen_Fade_Opacity_Player(player,JMG_Utility_Set_Screen_Color_Fade_Controller::opacity[x]*inverted+TempDistCalc,0.1f);
@@ -7243,7 +7498,7 @@
 					if (dist > vehicleWarnDistance)
 					{
 						screenEffectOn[x] = true;
-						float TempDistCalc = 1-(dist-maxSurviveDistance)/(vehicleWarnDistance-maxSurviveDistance);
+						float TempDistCalc = min(1-(dist-maxSurviveDistance)/(vehicleWarnDistance-maxSurviveDistance),1.0f);
 						float inverted = 1-TempDistCalc;
 						Set_Screen_Fade_Color_Player(player,JMG_Utility_Set_Screen_Color_Fade_Controller::color[x].X*inverted+screenFadeColor.X,JMG_Utility_Set_Screen_Color_Fade_Controller::color[x].Y*inverted+screenFadeColor.Y,JMG_Utility_Set_Screen_Color_Fade_Controller::color[x].Z*inverted+screenFadeColor.Z,0.1f);
 						Set_Screen_Fade_Opacity_Player(player,JMG_Utility_Set_Screen_Color_Fade_Controller::opacity[x]*inverted+TempDistCalc,0.1f);
@@ -7470,7 +7725,10 @@
 		int id = Get_Int_Parameter("ID");
 		GameObject *object = id ? (id == -1 ? sender : Commands->Find_Object(id)) : obj;
 		if (object)
-			Commands->Send_Custom_Event(obj,object,Get_Int_Parameter("SendCustom"),Get_Int_Parameter("Param"),Get_Float_Parameter("Delay"));
+		{
+			int Param = Get_Int_Parameter("Param");
+			Commands->Send_Custom_Event(obj,object,Get_Int_Parameter("SendCustom"),Param == -1 ? param : Param,Get_Float_Parameter("Delay"));
+		}
 		this->Destroy_Script();
 	}
 }
@@ -7531,7 +7789,10 @@
 		int id = Get_Int_Parameter("ID");
 		GameObject *object = id ? (id == -1 ? sender : Commands->Find_Object(id)) : obj;
 		if (object)
-			Commands->Send_Custom_Event(obj,object,Get_Int_Parameter("SendCustom"),Get_Int_Parameter("Param"),Get_Float_Parameter("Delay"));
+		{
+			int Param = Get_Int_Parameter("Param");
+			Commands->Send_Custom_Event(obj,object,Get_Int_Parameter("SendCustom"),Param == -1 ? param : Param,Get_Float_Parameter("Delay"));
+		}
 		this->Destroy_Script();
 	}
 }
@@ -7704,10 +7965,13 @@
 {
 	if (message == custom)
 	{
+		if (BasicObjectiveSystem.Get_Objective_Status(Get_Int_Parameter("ObjectiveID")) != NewObjectiveSystem::Accomplished)
+		{
 		BasicObjectiveSystem.Add_Objective(Get_Int_Parameter("ObjectiveID"),NewObjectiveSystem::Primary,NewObjectiveSystem::Hidden,0,"",0);
 		BasicObjectiveSystem.Set_Objective_Status(Get_Int_Parameter("ObjectiveID"),NewObjectiveSystem::Failed);
 	}
 }
+}
 void JMG_Utility_Force_Player_Team_At_Gameover::Created(GameObject *obj)
 {
 	team = Get_Int_Parameter("Team");
@@ -7759,7 +8023,7 @@
 		if (EnemyID)
 		{
 			GameObject *Target = Commands->Find_Object(EnemyID);
-			if (!Target || !Commands->Get_Health(Target) || Commands->Get_Player_Type(Target) == Commands->Get_Player_Type(obj))
+			if (!Target || !Commands->Get_Health(Target) || (Commands->Get_Player_Type(obj) != -2 && Commands->Get_Player_Type(Target) == Commands->Get_Player_Type(obj)))
 			{
 				EnemyID = 0;
 				Goto_Location(obj);
@@ -7793,7 +8057,7 @@
 }
 void JMG_Utility_AI_Guardian_Generic::Damaged(GameObject *obj,GameObject *damager,float damage)
 {
-	if (damage <= 0 || (EnemyID && EnemyTimeOutTime) || Commands->Get_Player_Type(damager) == Commands->Get_Player_Type(obj))
+	if (damage <= 0 || (EnemyID && EnemyTimeOutTime) || (Commands->Get_Player_Type(obj) != -2 && Commands->Get_Player_Type(damager) == Commands->Get_Player_Type(obj)))
 		return;
 	EnemyID = Commands->Get_ID(damager);
 	EnemyTimeOutTime = Commands->Get_Random_Int(2,5);
@@ -8302,7 +8566,7 @@
 	rate = Get_Float_Parameter("Rate");
 	repeat = Get_Int_Parameter("Repeat") ? true : false;
 	id = Get_Int_Parameter("ID");
-	message = Get_Int_Parameter("Message");
+	custom = Get_Int_Parameter("Message");
 	param = Get_Int_Parameter("Param");
 	enabled = Get_Int_Parameter("StartsEnabled") ? true : false;
 	enableCustom = Get_Int_Parameter("EnableCustom");
@@ -8330,7 +8594,7 @@
 			{
 				GameObject *object = !id ? obj : Commands->Find_Object(id);
 				if (object)
-					Commands->Send_Custom_Event(obj,object,message,param,0);
+					Commands->Send_Custom_Event(obj,object,custom,param,0);
 				if (!repeat)
 				{
 					Destroy_Script();
@@ -8348,7 +8612,7 @@
 	rate = Get_Float_Parameter("Rate");
 	repeat = Get_Int_Parameter("Repeat") ? true : false;
 	id = Get_Int_Parameter("ID");
-	message = Get_Int_Parameter("Message");
+	custom = Get_Int_Parameter("Message");
 	param = Get_Int_Parameter("Param");
 	enabled = Get_Int_Parameter("StartsEnabled") ? true : false;
 	enableCustom = Get_Int_Parameter("EnableCustom");
@@ -8376,7 +8640,7 @@
 			{
 				GameObject *object = !id ? obj : Commands->Find_Object(id);
 				if (object)
-					Commands->Send_Custom_Event(obj,object,message,param,0);
+					Commands->Send_Custom_Event(obj,object,custom,param,0);
 				if (!repeat)
 				{
 					Destroy_Script();
@@ -8401,7 +8665,7 @@
 	rate = Get_Float_Parameter("Rate");
 	repeat = Get_Int_Parameter("Repeat") ? true : false;
 	id = Get_Int_Parameter("ID");
-	message = Get_Int_Parameter("Message");
+	custom = Get_Int_Parameter("Message");
 	param = Get_Int_Parameter("Param");
 	enabled = Get_Int_Parameter("StartsEnabled") ? true : false;
 	enableCustom = Get_Int_Parameter("EnableCustom");
@@ -8458,7 +8722,7 @@
 {
 	GameObject *object = !id ? obj : Commands->Find_Object(id);
 	if (object)
-		Commands->Send_Custom_Event(obj,object,message,param == -1 ? paramOverride : param,0);
+		Commands->Send_Custom_Event(obj,object,custom,param == -1 ? paramOverride : param,0);
 	if (!repeat)
 		Destroy_Script();
 }
@@ -8609,7 +8873,7 @@
 		lastTriggerTime = currentTime;
 		GameObject *object = id ? (id == -1 ? sender : Commands->Find_Object(id)) : obj;
 		if (object)
-			Commands->Send_Custom_Event(obj,object,sendCustom,params,delay);
+			Commands->Send_Custom_Event(obj,object,sendCustom,params == -1 ? param : params,delay);
 	}
 	if (message == enableCustom)
 	{
